<?php
/**
 * StandortJsonldWriteStandortRead
 *
 * PHP version 7.4
 *
 * @category Class
 * @package  SLIS\Adapter\Hub
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * slis hub
 *
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.7.4
 * Contact: dev@slis.io
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.1.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Hub\Model;

use \ArrayAccess;
use \SLIS\Adapter\Hub\ObjectSerializer;

/**
 * StandortJsonldWriteStandortRead Class Doc Comment
 *
 * @category Class
 * @package  SLIS\Adapter\Hub
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<string, mixed>
 */
class StandortJsonldWriteStandortRead implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'Standort.jsonld-write_standort.read';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'atContext' => '\SLIS\Adapter\Hub\Model\AdresseJsonldCreateContext',
        'atId' => 'string',
        'atType' => 'string',
        'telefon' => 'string',
        'fax' => 'string',
        'email' => 'string',
        'adresse' => '\SLIS\Adapter\Hub\Model\AdresseJsonldWriteStandortRead',
        'ansprechpartner' => '\SLIS\Adapter\Hub\Model\AnsprechpartnerJsonldWriteStandortRead[]',
        'netzwerke' => '\SLIS\Adapter\Hub\Model\NetzwerkJsonldWriteStandortRead[]',
        'hauptsitz' => 'bool',
        'uuid' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'atContext' => null,
        'atId' => null,
        'atType' => null,
        'telefon' => null,
        'fax' => null,
        'email' => null,
        'adresse' => null,
        'ansprechpartner' => null,
        'netzwerke' => null,
        'hauptsitz' => null,
        'uuid' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static array $openAPINullables = [
        'atContext' => false,
		'atId' => false,
		'atType' => false,
		'telefon' => false,
		'fax' => true,
		'email' => false,
		'adresse' => false,
		'ansprechpartner' => false,
		'netzwerke' => false,
		'hauptsitz' => false,
		'uuid' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected array $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of nullable properties
     *
     * @return array
     */
    protected static function openAPINullables(): array
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return boolean[]
     */
    private function getOpenAPINullablesSetToNull(): array
    {
        return $this->openAPINullablesSetToNull;
    }

    /**
     * Checks if a property is nullable
     *
     * @param string $property
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        return self::openAPINullables()[$property] ?? false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @param string $property
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        return in_array($property, $this->getOpenAPINullablesSetToNull(), true);
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'atContext' => '@context',
        'atId' => '@id',
        'atType' => '@type',
        'telefon' => 'telefon',
        'fax' => 'fax',
        'email' => 'email',
        'adresse' => 'adresse',
        'ansprechpartner' => 'ansprechpartner',
        'netzwerke' => 'netzwerke',
        'hauptsitz' => 'hauptsitz',
        'uuid' => 'uuid'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'atContext' => 'setAtContext',
        'atId' => 'setAtId',
        'atType' => 'setAtType',
        'telefon' => 'setTelefon',
        'fax' => 'setFax',
        'email' => 'setEmail',
        'adresse' => 'setAdresse',
        'ansprechpartner' => 'setAnsprechpartner',
        'netzwerke' => 'setNetzwerke',
        'hauptsitz' => 'setHauptsitz',
        'uuid' => 'setUuid'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'atContext' => 'getAtContext',
        'atId' => 'getAtId',
        'atType' => 'getAtType',
        'telefon' => 'getTelefon',
        'fax' => 'getFax',
        'email' => 'getEmail',
        'adresse' => 'getAdresse',
        'ansprechpartner' => 'getAnsprechpartner',
        'netzwerke' => 'getNetzwerke',
        'hauptsitz' => 'getHauptsitz',
        'uuid' => 'getUuid'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('atContext', $data ?? [], null);
        $this->setIfExists('atId', $data ?? [], null);
        $this->setIfExists('atType', $data ?? [], null);
        $this->setIfExists('telefon', $data ?? [], null);
        $this->setIfExists('fax', $data ?? [], null);
        $this->setIfExists('email', $data ?? [], null);
        $this->setIfExists('adresse', $data ?? [], null);
        $this->setIfExists('ansprechpartner', $data ?? [], null);
        $this->setIfExists('netzwerke', $data ?? [], null);
        $this->setIfExists('hauptsitz', $data ?? [], null);
        $this->setIfExists('uuid', $data ?? [], null);
    }

    /**
    * Sets $this->container[$variableName] to the given data or to the given default Value; if $variableName
    * is nullable and its value is set to null in the $fields array, then mark it as "set to null" in the
    * $this->openAPINullablesSetToNull array
    *
    * @param string $variableName
    * @param array  $fields
    * @param mixed  $defaultValue
    */
    private function setIfExists(string $variableName, array $fields, $defaultValue): void
    {
        if (self::isNullable($variableName) && array_key_exists($variableName, $fields) && is_null($fields[$variableName])) {
            $this->openAPINullablesSetToNull[] = $variableName;
        }

        $this->container[$variableName] = $fields[$variableName] ?? $defaultValue;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets atContext
     *
     * @return \SLIS\Adapter\Hub\Model\AdresseJsonldCreateContext|null
     */
    public function getAtContext()
    {
        return $this->container['atContext'];
    }

    /**
     * Sets atContext
     *
     * @param \SLIS\Adapter\Hub\Model\AdresseJsonldCreateContext|null $atContext atContext
     *
     * @return self
     */
    public function setAtContext($atContext)
    {

        if (is_null($atContext)) {
            throw new \InvalidArgumentException('non-nullable atContext cannot be null');
        }

        $this->container['atContext'] = $atContext;

        return $this;
    }

    /**
     * Gets atId
     *
     * @return string|null
     */
    public function getAtId()
    {
        return $this->container['atId'];
    }

    /**
     * Sets atId
     *
     * @param string|null $atId atId
     *
     * @return self
     */
    public function setAtId($atId)
    {

        if (is_null($atId)) {
            throw new \InvalidArgumentException('non-nullable atId cannot be null');
        }

        $this->container['atId'] = $atId;

        return $this;
    }

    /**
     * Gets atType
     *
     * @return string|null
     */
    public function getAtType()
    {
        return $this->container['atType'];
    }

    /**
     * Sets atType
     *
     * @param string|null $atType atType
     *
     * @return self
     */
    public function setAtType($atType)
    {

        if (is_null($atType)) {
            throw new \InvalidArgumentException('non-nullable atType cannot be null');
        }

        $this->container['atType'] = $atType;

        return $this;
    }

    /**
     * Gets telefon
     *
     * @return string|null
     */
    public function getTelefon()
    {
        return $this->container['telefon'];
    }

    /**
     * Sets telefon
     *
     * @param string|null $telefon telefon
     *
     * @return self
     */
    public function setTelefon($telefon)
    {

        if (is_null($telefon)) {
            throw new \InvalidArgumentException('non-nullable telefon cannot be null');
        }

        $this->container['telefon'] = $telefon;

        return $this;
    }

    /**
     * Gets fax
     *
     * @return string|null
     */
    public function getFax()
    {
        return $this->container['fax'];
    }

    /**
     * Sets fax
     *
     * @param string|null $fax fax
     *
     * @return self
     */
    public function setFax($fax)
    {

        if (is_null($fax)) {
            array_push($this->openAPINullablesSetToNull, 'fax');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('fax', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['fax'] = $fax;

        return $this;
    }

    /**
     * Gets email
     *
     * @return string|null
     */
    public function getEmail()
    {
        return $this->container['email'];
    }

    /**
     * Sets email
     *
     * @param string|null $email email
     *
     * @return self
     */
    public function setEmail($email)
    {

        if (is_null($email)) {
            throw new \InvalidArgumentException('non-nullable email cannot be null');
        }

        $this->container['email'] = $email;

        return $this;
    }

    /**
     * Gets adresse
     *
     * @return \SLIS\Adapter\Hub\Model\AdresseJsonldWriteStandortRead|null
     */
    public function getAdresse()
    {
        return $this->container['adresse'];
    }

    /**
     * Sets adresse
     *
     * @param \SLIS\Adapter\Hub\Model\AdresseJsonldWriteStandortRead|null $adresse adresse
     *
     * @return self
     */
    public function setAdresse($adresse)
    {

        if (is_null($adresse)) {
            throw new \InvalidArgumentException('non-nullable adresse cannot be null');
        }

        $this->container['adresse'] = $adresse;

        return $this;
    }

    /**
     * Gets ansprechpartner
     *
     * @return \SLIS\Adapter\Hub\Model\AnsprechpartnerJsonldWriteStandortRead[]|null
     */
    public function getAnsprechpartner()
    {
        return $this->container['ansprechpartner'];
    }

    /**
     * Sets ansprechpartner
     *
     * @param \SLIS\Adapter\Hub\Model\AnsprechpartnerJsonldWriteStandortRead[]|null $ansprechpartner ansprechpartner
     *
     * @return self
     */
    public function setAnsprechpartner($ansprechpartner)
    {

        if (is_null($ansprechpartner)) {
            throw new \InvalidArgumentException('non-nullable ansprechpartner cannot be null');
        }

        $this->container['ansprechpartner'] = $ansprechpartner;

        return $this;
    }

    /**
     * Gets netzwerke
     *
     * @return \SLIS\Adapter\Hub\Model\NetzwerkJsonldWriteStandortRead[]|null
     */
    public function getNetzwerke()
    {
        return $this->container['netzwerke'];
    }

    /**
     * Sets netzwerke
     *
     * @param \SLIS\Adapter\Hub\Model\NetzwerkJsonldWriteStandortRead[]|null $netzwerke netzwerke
     *
     * @return self
     */
    public function setNetzwerke($netzwerke)
    {

        if (is_null($netzwerke)) {
            throw new \InvalidArgumentException('non-nullable netzwerke cannot be null');
        }

        $this->container['netzwerke'] = $netzwerke;

        return $this;
    }

    /**
     * Gets hauptsitz
     *
     * @return bool|null
     */
    public function getHauptsitz()
    {
        return $this->container['hauptsitz'];
    }

    /**
     * Sets hauptsitz
     *
     * @param bool|null $hauptsitz hauptsitz
     *
     * @return self
     */
    public function setHauptsitz($hauptsitz)
    {

        if (is_null($hauptsitz)) {
            throw new \InvalidArgumentException('non-nullable hauptsitz cannot be null');
        }

        $this->container['hauptsitz'] = $hauptsitz;

        return $this;
    }

    /**
     * Gets uuid
     *
     * @return string|null
     */
    public function getUuid()
    {
        return $this->container['uuid'];
    }

    /**
     * Sets uuid
     *
     * @param string|null $uuid uuid
     *
     * @return self
     */
    public function setUuid($uuid)
    {

        if (is_null($uuid)) {
            throw new \InvalidArgumentException('non-nullable uuid cannot be null');
        }

        $this->container['uuid'] = $uuid;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


